From 249a689b1c8c26efa0288fb4d3cf007a58b03e2c Mon Sep 17 00:00:00 2001
From: Mark Reynolds <mreynolds@redhat.com>
Date: Thu, 21 Feb 2013 10:28:23 -0500
Subject: [PATCH] Ticket 528 - RFE - get rid of instance specific scripts (part 2)

Bug Description:  There was a lot of rundant code in the scripts, and
                  hardcoded paths.

Fix Description:  Create new functions in DSUtil.pm(for perl scripts), and
                  create a new shared lib file for the shell scripts.  Redundant
                  code was turned into functions and placed in these files.  Also
                  replaced hardcoded paths with the proper macro values.

https://fedorahosted.org/389/ticket/528

Reviewed by: ?
---
 Makefile.am                                        |    3 +-
 Makefile.in                                        |    3 +-
 ldap/admin/src/scripts/DSSharedLib.in              |   68 +++++++++++
 ldap/admin/src/scripts/DSUtil.pm.in                |   90 +++++++++++++--
 ldap/admin/src/scripts/bak2db.in                   |   88 ++++-----------
 ldap/admin/src/scripts/bak2db.pl.in                |   66 +----------
 ldap/admin/src/scripts/cleanallruv.pl.in           |   65 +----------
 ldap/admin/src/scripts/db2bak.in                   |   93 ++++------------
 ldap/admin/src/scripts/db2bak.pl.in                |   69 +----------
 ldap/admin/src/scripts/db2index.in                 |   96 ++++------------
 ldap/admin/src/scripts/db2index.pl.in              |   67 +----------
 ldap/admin/src/scripts/db2ldif.in                  |  121 +++++---------------
 ldap/admin/src/scripts/db2ldif.pl.in               |   68 +----------
 ldap/admin/src/scripts/dbverify.in                 |  104 ++++-------------
 ldap/admin/src/scripts/dn2rdn.in                   |   88 ++++-----------
 ldap/admin/src/scripts/fixup-linkedattrs.pl.in     |   68 +----------
 ldap/admin/src/scripts/fixup-memberof.pl.in        |   67 +----------
 ldap/admin/src/scripts/ldif2db.in                  |   82 +++-----------
 ldap/admin/src/scripts/ldif2db.pl.in               |   67 +----------
 ldap/admin/src/scripts/ldif2ldap.in                |   87 +++-----------
 ldap/admin/src/scripts/monitor.in                  |   83 +++-----------
 ldap/admin/src/scripts/ns-accountstatus.pl.in      |   67 +----------
 ldap/admin/src/scripts/ns-activate.pl.in           |   66 +----------
 ldap/admin/src/scripts/ns-inactivate.pl.in         |   67 +----------
 ldap/admin/src/scripts/ns-newpwpolicy.pl.in        |   44 +-------
 ldap/admin/src/scripts/restart-slapd.in            |   72 +++---------
 ldap/admin/src/scripts/restoreconfig.in            |   94 ++++------------
 ldap/admin/src/scripts/saveconfig.in               |   91 ++++------------
 ldap/admin/src/scripts/schema-reload.pl.in         |   67 +----------
 ldap/admin/src/scripts/start-slapd.in              |   66 +++--------
 ldap/admin/src/scripts/stop-slapd.in               |   65 +++--------
 ldap/admin/src/scripts/suffix2instance.in          |   88 +++-----------
 ldap/admin/src/scripts/syntax-validate.pl.in       |   67 +----------
 ldap/admin/src/scripts/upgradedb.in                |   77 ++-----------
 ldap/admin/src/scripts/upgradednformat.in          |   98 ++++-------------
 ldap/admin/src/scripts/usn-tombstone-cleanup.pl.in |   66 +----------
 ldap/admin/src/scripts/verify-db.pl.in             |   39 +------
 ldap/admin/src/scripts/vlvindex.in                 |   92 ++++------------
 38 files changed, 596 insertions(+), 2173 deletions(-)
 create mode 100644 ldap/admin/src/scripts/DSSharedLib.in

diff --git a/Makefile.am b/Makefile.am
index 06a4692..9f52f0b 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -117,7 +117,7 @@ CLEANFILES =  dberrstrs.h ns-slapd.properties \
 	ldap/ldif/template-ldapi-autobind.ldif ldap/ldif/template-ldapi-default.ldif \
 	ldap/ldif/template-ldapi.ldif ldap/ldif/template-locality.ldif ldap/ldif/template-org.ldif \
 	ldap/ldif/template-orgunit.ldif ldap/ldif/template-pampta.ldif ldap/ldif/template-sasl.ldif \
-	ldap/ldif/template-state.ldif ldap/ldif/template-suffix-db.ldif \
+	ldap/ldif/template-state.ldif ldap/ldif/template-suffix-db.ldif ldap/admin/src/scripts/DSSharedLib \
 	ldap/admin/src/scripts/bak2db ldap/admin/src/scripts/db2bak ldap/admin/src/scripts/upgradedb \
 	ldap/admin/src/scripts/db2index ldap/admin/src/scripts/db2ldif \
 	ldap/admin/src/scripts/dn2rdn ldap/admin/src/scripts/ldif2db \
@@ -370,6 +370,7 @@ sbin_SCRIPTS = ldap/admin/src/scripts/setup-ds.pl \
 	ldap/admin/src/scripts/verify-db.pl \
 	ldap/admin/src/scripts/dbverify \
 	ldap/admin/src/scripts/upgradedb \
+	ldap/admin/src/scripts/DSSharedLib \
     wrappers/ldap-agent
 
 bin_SCRIPTS = ldap/servers/slapd/tools/rsearch/scripts/dbgen.pl \
diff --git a/ldap/admin/src/scripts/DSSharedLib.in b/ldap/admin/src/scripts/DSSharedLib.in
new file mode 100644
index 0000000..7b1b35d
--- /dev/null
+++ b/ldap/admin/src/scripts/DSSharedLib.in
@@ -0,0 +1,68 @@
+libpath_add()
+{
+    [ -z "$1" ] && return
+    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
+}
+
+#
+#  get_server_id()
+#
+#  First grab all the server instances
+#  Then check if a server id was provided, if not, set
+#  the server id if there is only one instance. 
+#  If a servid was provided, make sure its a valid instance name.
+#
+get_server_id()
+{
+    dir=$1
+    servid=$2
+    first="yes"
+    inst_count=0
+    rc=0
+    
+    for i in `ls $dir/dirsrv-* 2>/dev/null`
+    do
+        if [ $i != '$dir/dirsrv-admin' ]
+        then
+            inst_count=`expr $inst_count + 1`
+            id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
+            if  [ $first == "yes" ]
+            then
+                instances=$id
+                first="no"
+            else
+                instances=$instances", $id"
+            fi
+            name=$id
+        fi
+    done
+    
+    if [ -z $servid ]
+    then
+        # server id not provided, check if there is only one instance
+        if [ $inst_count -eq 1 ]
+        then
+            servid=$name
+        else 
+            # multiple instances, can not set server id.  Return list of instances
+            servid=$instances
+            rc=1
+        fi
+    elif [ $servid == slapd-* ]
+    then
+        servid=`echo "$servid" | sed -e 's/slapd-//'`
+    elif [ $servid == dirsrv-* ]
+    then
+        servid=`echo "$servid" | sed -e 's/dirsrv-//'`
+    fi
+    
+    if ! [ -a $dir/dirsrv-$servid ]
+    then
+        # invalid instance name, return the "valid" instance names
+        servid=$instances
+        rc=1
+    fi
+
+    echo $servid
+    exit $rc
+}
diff --git a/ldap/admin/src/scripts/DSUtil.pm.in b/ldap/admin/src/scripts/DSUtil.pm.in
index b6b9b86..8f368c2 100644
--- a/ldap/admin/src/scripts/DSUtil.pm.in
+++ b/ldap/admin/src/scripts/DSUtil.pm.in
@@ -1212,20 +1212,13 @@ sub get_prefix {
 # Grab the host, port, and rootDN from the config file of the server instance
 # if the values are missing
 sub get_missing_info {
-    my $prefix = shift;
+    my $dir = shift;
     my $servID = shift;
-    my $instances = shift;
     my $host = shift;
     my $port = shift; 
     my $rootdn = shift;
     
-    unless ( -e "$prefix/etc/dirsrv/slapd-$servID/dse.ldif" ){
-        print (STDERR "Invalid server identifer: $servID\n");
-        print (STDERR "Available instances: $instances\n");
-        exit (1);
-    }
-    
-    open (DSE, "<$prefix/etc/dirsrv/slapd-$servID/dse.ldif") || die "Failed to open config file $prefix/etc/dirsrv/slapd-$servID/dse.ldif $!\n";
+    open (DSE, "<$dir/slapd-$servID/dse.ldif") || die "Failed to open config file $dir/slapd-$servID/dse.ldif $!\n";
         while(<DSE>){
         if ($host eq "" && $_ =~ /^nsslapd-localhost: (.*)/){
                 $host = $1;
@@ -1241,6 +1234,85 @@ sub get_missing_info {
     return $host, $port, $rootdn;
 }
 
+sub get_server_id {
+    my $servid = shift;
+    my $dir = shift;
+    my $first = "yes";
+    my $instance_count = 0;
+    my $instances = "";
+    my $name = "";
+    my $file;
+    
+    opendir(DIR, "$dir");
+    my @files = readdir(DIR);
+    foreach $file (@files){
+        if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
+            $instance_count++;
+            if($file =~ /dirsrv-(.*)/){
+                if($first eq "yes"){
+                    $instances=$1;
+                    $first = "no";
+                } else {
+                    $instances=$instances . ", $1";
+                }
+                $name = $1;
+            }
+        }
+    }
+    if($servid eq ""){
+        if ($instance_count == 1){
+            $servid = $name;
+        } else {
+            print "You must supply a valid server instance identifier.  Use -Z to specify instance name\n";
+            print "Available instances: $instances\n";
+            exit (1);
+        }
+    } elsif ($servid =~ /^dirsrv-/){
+        # strip off "dirsrv-"
+        $servid =~ s/^dirsrv-//;
+    } elsif ($servid =~ /^slapd-/){
+        # strip off "slapd-"
+        $servid =~ s/^slapd-//;
+    }
+    
+    unless ( -e "$dir/dirsrv-$servid" ){
+        print (STDERR "instance dir: $dir/dirsrv-$servid\n");
+        print (STDERR "Invalid server identifer: $servid\n");
+        print (STDERR "Available instances: $instances\n");
+        exit (1);
+    }
+    
+    return $servid;
+}
+
+sub get_password_from_file {
+    my $passwd = shift;
+    my $passwdfile = shift;
+    
+    if ($passwdfile ne ""){
+        # Open file and get the password
+        unless (open (RPASS, $passwdfile)) {
+            die "Error, cannot open password file $passwdfile\n";
+        }
+        $passwd = <RPASS>;
+        chomp($passwd);
+        close(RPASS);
+    } elsif ($passwd eq "-"){
+        # Read the password from terminal
+        print "Bind Password: ";
+        # Disable console echo
+        system("@sttyexec@ -echo") if -t STDIN;
+        # read the answer
+        $passwd = <STDIN>;
+        # Enable console echo
+        system("@sttyexec@ echo") if -t STDIN;
+        print "\n";
+        chop($passwd); # trim trailing newline
+    }
+    
+    return $passwd;
+}
+
 1;
 
 # emacs settings
diff --git a/ldap/admin/src/scripts/bak2db.in b/ldap/admin/src/scripts/bak2db.in
index 0fe5240..56e038f 100755
--- a/ldap/admin/src/scripts/bak2db.in
+++ b/ldap/admin/src/scripts/bak2db.in
@@ -1,23 +1,8 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
+libpath_add "@libdir@/dirsrv/"
 libpath_add "@nss_libdir@"
 libpath_add "@libdir@"
 libpath_add "@pcre_libdir@"
@@ -26,25 +11,28 @@ export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
+usage()
+{
+    echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
+}
+
 if [ $# -lt 1 ] || [ $# -gt 7 ]
 then
-    echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
+    usage
     exit 1
 elif [ "$1" == "-*" ]
 then
-    echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
+    usage
     exit 1
 else
     archivedir=$1
     shift
 fi
-
-first="yes"
-args=""      
+    
 while getopts "hn:Z:qd:vi:a:SD:" flag
 do
     case $flag in
-        h) echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
+        h) usage
            exit 0;;
         Z) servid=$OPTARG;; 
         n) args=$args" -n $OPTARG";;
@@ -55,57 +43,22 @@ do
         i) args=$args" -i $OPTARG";;
         a) archivedir=$OPTARG;;
         S) args=$args" -S";;
-        ?) echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
+        ?) usage
            exit 1;;
     esac
 done
 
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done
-
-if [ -z $servid ]
-then
-    # server id not provided, check if there is only one instance
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: bak2db archivedir [-Z serverID] [-n backendname] [-q] | [-h]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
-then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ 1 = `expr $archivedir : "\/"` ]
 then
     archivedir=$archivedir
@@ -114,5 +67,4 @@ else
     archivedir=`pwd`/$archivedir
 fi
 
-cd $server_sbin
-./ns-slapd archive2db -D $configdir -a $archivedir $args
+@sbindir@/ns-slapd archive2db -D $configdir -a $archivedir $args
diff --git a/ldap/admin/src/scripts/bak2db.pl.in b/ldap/admin/src/scripts/bak2db.pl.in
index 0352ed1..a6cb72d 100644
--- a/ldap/admin/src/scripts/bak2db.pl.in
+++ b/ldap/admin/src/scripts/bak2db.pl.in
@@ -67,7 +67,6 @@ $passwdfile = "";
 $host = "";
 $port = "";
 $i = 0;
-$prefix = DSUtil::get_prefix();
 
 while ($i <= $#ARGV) {
 	if ("$ARGV[$i]" eq "-a") {	# backup directory
@@ -99,62 +98,10 @@ if ($archivedir eq ""){
     exit(1);
 }
 
-$first = "yes";
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
-if ($passwdfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $passwdfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$passwd = <RPASS>;
-	chomp($passwd);
-	close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
 if ( $rootdn eq "" || $passwd eq "") { &usage; exit(1); }
 ($s, $m, $h, $dy, $mn, $yr, $wdy, $ydy, $r) = localtime(time);
 $mn++; $yr += 1900;
@@ -168,7 +115,7 @@ if (!$isabs) {
     $archivedir = File::Spec->rel2abs( $archivedir );
 }
 $dn = "dn: cn=$taskname, cn=restore, cn=tasks, cn=config\n";
-$misc = "changetype: add\nobjectclass: top\nobjectclass: extensibleObject\n";
+$misc = "objectclass: top\nobjectclass: extensibleObject\n";
 $cn = "cn: $taskname\n";
 if ($instance ne "") {
 	$nsinstance = "nsInstance: ${instance}\n";
@@ -178,12 +125,11 @@ $nsdbtype = "nsDatabaseType: $dbtype\n";
 $entry = "${dn}${misc}${cn}${nsinstance}${nsarchivedir}${nsdbtype}";
 $vstr = "";
 if ($verbose != 0) { $vstr = "-v"; }
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 open(FOO, "| ldapmodify @ldaptool_opts@ $vstr -h $info[0] -p $info[1] -D $info[2] -w \"$passwd\" -a" );
diff --git a/ldap/admin/src/scripts/cleanallruv.pl.in b/ldap/admin/src/scripts/cleanallruv.pl.in
index 7cdfb2d..267305d 100644
--- a/ldap/admin/src/scripts/cleanallruv.pl.in
+++ b/ldap/admin/src/scripts/cleanallruv.pl.in
@@ -64,15 +64,12 @@ $abort = "";
 $verbose = 0;
 $host = "";
 $port = "";
-$first = "yes";
-$prefix = DSUtil::get_prefix();
 
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 
@@ -131,61 +128,9 @@ while ($i <= $#ARGV)
     $i++;
 }
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
-
-if ($passwdfile ne ""){
-# Open file and get the password
-    unless (open (RPASS, $passwdfile)) {
-        die "Error, cannot open password file $passwdfile\n";
-    }
-    $passwd = <RPASS>;
-    chomp($passwd);
-    close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-    print "Bind Password: ";
-    # Disable console echo
-    system("@sttyexec@ -echo") if -t STDIN;
-    # read the answer
-    $passwd = <STDIN>;
-    # Enable console echo
-    system("@sttyexec@ echo") if -t STDIN;
-    print "\n";
-    chop($passwd); # trim trailing newline
-}
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
 if ( $info[2] eq "" || $passwd eq "" || $basedn eq "" || $rid eq "") 
 { 
diff --git a/ldap/admin/src/scripts/db2bak.in b/ldap/admin/src/scripts/db2bak.in
index 8e53722..b4dd456 100755
--- a/ldap/admin/src/scripts/db2bak.in
+++ b/ldap/admin/src/scripts/db2bak.in
@@ -1,41 +1,27 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@libdir@/dirsrv/"
+libpath_add "@nss_libdir@"
+libpath_add "@libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
+usage()
+{
+    echo "Usage: db2bak [archivedir] [-Z serverID] [-q] [-h]"
+}
+
 if [ $# -gt 4 ]
 then
-    echo "Usage: db2bak [archivedir] [-Z serverID] [-q] [-h]"
+    usage
     exit 1
 fi
 
-first="yes"
-bak_dir=""
-args=""
-cd $server_sbin
 if [ "$#" -gt 0 ]
 then
   if ["$1" != "-*" ] 
@@ -47,7 +33,7 @@ then
   while getopts "hqd:Z:vi:a:SD" flag
   do
     case $flag in
-        h) echo "Usage: db2bak [archivedir] [-Z serverID] [-q] [-h]"
+        h) usage
            exit 0;;
         q) args=$args" -g";;
         v) args=$args" -v";;
@@ -57,62 +43,27 @@ then
         a) $bakdir=$OPTARG;;
         d) args=$args" -d $OPTARG";;
         Z) servid=$OPTARG;;
-        ?) echo "Usage: db2bak [archivedir] [-Z serverID] [-q] [-h]"
+        ?) usage
            exit 1;;
     esac
   done
 fi
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: db2bak [archivedir] [-Z serverID] [-q] [-h]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ -z $bak_dir ]
 then
-    bak_dir=$prefix/var/lib/dirsrv/slapd-$servid/bak/$servid-`date +%Y_%m_%d_%H_%M_%S`
+    bak_dir=@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/$servid-`date +%Y_%m_%d_%H_%M_%S`
 fi
 
 echo "Back up directory: $bak_dir"
-./ns-slapd db2archive -D $configdir -a $bak_dir $args
+@sbindir@/ns-slapd db2archive -D $configdir -a $bak_dir $args
diff --git a/ldap/admin/src/scripts/db2bak.pl.in b/ldap/admin/src/scripts/db2bak.pl.in
index f45a834..d406a2c 100644
--- a/ldap/admin/src/scripts/db2bak.pl.in
+++ b/ldap/admin/src/scripts/db2bak.pl.in
@@ -64,8 +64,6 @@ $passwdfile = "";
 $i = 0;
 $host = "";
 $port = "";
-$first = "yes";
-$prefix = DSUtil::get_prefix();
 
 while ($i <= $#ARGV) {
 	if ("$ARGV[$i]" eq "-a") {	# backup directory
@@ -90,63 +88,11 @@ while ($i <= $#ARGV) {
 	$i++;
 }
 
-opendir(DIR, "$prefix/etc/sysconfig");
-@files = readdir(DIR);
-foreach $file (@files){
-    if($file =~ /^dirsrv-/ && $file ne "dirsrv-admin"){
-        $instance_count++;
-        if($file =~ /dirsrv-(.*)/){
-            if($first eq "yes"){
-                $instances=$1;
-                $first = "no";
-            } else {
-                $instances=$instances . ", $1";
-            }
-            $name = $1;
-        }
-    }
-}
-
-if($servid eq ""){
-    if ($instance_count == 1){
-        $servid = $name;
-    } else {
-        &usage;
-        print "You must supply a server instance identifier.  Use -Z to specify instance name\n";
-        print "Available instances: $instances\n";
-        exit (1);
-    }
-} elsif ($servid =~ /^dirsrv-/){
-    # strip off "dirsrv-"
-    $servid =~ s/^dirsrv-//;
-} elsif ($servid =~ /^slapd-/){
-    # strip off "slapd-"
-    $servid =~ s/^slapd-//;
-}
-@info = DSUtil::get_missing_info($prefix, $servid, $instances, $host, $port, $rootdn);
+$servid = DSUtil::get_server_id($servid, "@initconfigdir@");
+@info = DSUtil::get_missing_info("@instconfigdir@", $servid, $host, $port, $rootdn);
+$mybakdir = "@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak";
+$passwd = DSUtil::get_password_from_file($passwd, $passwdfile);
 
-$mybakdir = "$prefix/var/lib/dirsrv/slapd-$servid/bak";
-
-if ($passwdfile ne ""){
-# Open file and get the password
-	unless (open (RPASS, $passwdfile)) {
-		die "Error, cannot open password file $passwdfile\n";
-	}
-	$passwd = <RPASS>;
-	chomp($passwd);
-	close(RPASS);
-} elsif ($passwd eq "-"){
-# Read the password from terminal
-	print "Bind Password: ";
-	# Disable console echo
-	system("@sttyexec@ -echo") if -t STDIN;
-	# read the answer
-	$passwd = <STDIN>;
-	# Enable console echo
-	system("@sttyexec@ echo") if -t STDIN;
-	print "\n";
-	chop($passwd); # trim trailing newline
-}
 if ( $info[2] eq "" || $passwd eq "") { &usage; exit(1); }
 ($s, $m, $h, $dy, $mn, $yr, $wdy, $ydy, $r) = localtime(time);
 $mn++; $yr += 1900;
@@ -155,19 +101,18 @@ if ($archivedir eq "") {
 	$archivedir = "${mybakdir}/$servid-${yr}_${mn}_${dy}_${h}_${m}_${s}";
 }
 $dn = "dn: cn=$taskname, cn=backup, cn=tasks, cn=config\n";
-$misc = "changetype: add\nobjectclass: top\nobjectclass: extensibleObject\n";
+$misc = "objectclass: top\nobjectclass: extensibleObject\n";
 $cn = "cn: $taskname\n";
 $nsarchivedir = "nsArchiveDir: $archivedir\n";
 $nsdbtype = "nsDatabaseType: $dbtype\n";
 $entry = "${dn}${misc}${cn}${nsarchivedir}${nsdbtype}";
 $vstr = "";
 if ($verbose != 0) { $vstr = "-v"; }
-$ENV{'PATH'} = "$prefix@ldaptool_bindir@:$prefix/usr/bin:@ldaptool_bindir@:/usr/bin";
+$ENV{'PATH'} = "@ldaptool_bindir@:/usr/bin:@ldaptool_bindir@:/usr/bin";
 
-DSUtil::libpath_add("$prefix@nss_libdir@");
-DSUtil::libpath_add("$prefix/usr/lib");
 DSUtil::libpath_add("@nss_libdir@");
 DSUtil::libpath_add("/usr/lib");
+DSUtil::libpath_add("/usr/lib64");
 
 $ENV{'SHLIB_PATH'} = "$ENV{'LD_LIBRARY_PATH'}";
 print("Back up directory: $archivedir host: $info[0] port: $info[1] binddn: $info[2]\n");
diff --git a/ldap/admin/src/scripts/db2index.in b/ldap/admin/src/scripts/db2index.in
index f735cfc..501f637 100755
--- a/ldap/admin/src/scripts/db2index.in
+++ b/ldap/admin/src/scripts/db2index.in
@@ -1,37 +1,25 @@
 #!/bin/sh
 
-libpath_add() {
-    [ -z "$1" ] && return
-    LD_LIBRARY_PATH=${LD_LIBRARY_PATH:+$LD_LIBRARY_PATH:}$1
-}
-
-server_dir="@libdir@/dirsrv/"
-SCRIPT=$(readlink -f $0)
-SCRIPTPATH=$(dirname $SCRIPT)
-if [ $SCRIPTPATH == "/usr/sbin" ]
-then
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/usr\/sbin//'`
-    server_sbin="/usr/sbin"
-else
-    prefix=`echo "$SCRIPTPATH" | sed -e 's/\/sbin//'`
-    server_sbin=$prefix"/sbin"
-fi
+source ./DSSharedLib
 
-libpath_add "$server_dir"
-libpath_add "$prefix@nss_libdir@"
-libpath_add "$prefix@libdir@"
-libpath_add "$prefix@pcre_libdir@"
+libpath_add "@libdir@/dirsrv/"
+libpath_add "@nss_libdir@"
+libpath_add "@libdir@"
+libpath_add "@pcre_libdir@"
 
 export LD_LIBRARY_PATH
 SHLIB_PATH=$LD_LIBRARY_PATH
 export SHLIB_PATH
 
-first="yes"
-args=""
+usage ()
+{
+    echo "Usage: db2index [-Z serverID] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
+}
+
 while getopts "hZ:n:s:t:T:vd:a:SD:x:" flag
 do
     case $flag in
-        h) echo "Usage: db2index [-Z serverID] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
+        h) usage
            exit 0;;
         Z) servid=$OPTARG;; 
         n) args=$args" -n $OPTARG"
@@ -46,72 +34,36 @@ do
         v) args=$args=" -v";;
         S) args=$args=" -S";;
         D) args=$args" -D $OPTARG";;
-        ?) echo "Usage: db2index [-Z serverID] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
+        ?) usage
            exit 1;;
     esac
 done
 
 if [ -z $benameopt ] && [ -z $includeSuffix ]
 then
-    echo "Usage: db2index [-Z serverID] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
+    usage
     exit 1;
 fi
 
-# server id not provided, check if there is only one instance
-inst_count=0
-for i in `ls $prefix/etc/sysconfig/dirsrv-* 2>/dev/null`
-do
-    if [ $i != '$prefix/etc/sysconfig/dirsrv-admin' ]
-    then
-        inst_count=`expr $inst_count + 1`
-        id=$(expr "$i" : ".*dirsrv-\([^)]*\).*")
-        if  [ $first == "yes" ]
-        then
-            instances=$id
-            first="no"
-        else
-            instances=$instances", $id"
-        fi
-        name=$id
-    fi
-done 
-    
-if [ -z $servid ]
-then
-    if [ $inst_count -eq 1 ]
-    then
-        servid=$name
-    else 
-        # error
-        echo "Usage: db2index [-Z serverID] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
-        echo "You must supply a server instance identifier.  Use -Z to specify instance name"
-        echo "Available instances: $instances"
-        exit 1
-    fi
-elif [ $servid == slapd-* ]
-then
-    servid=`echo "$servid" | sed -e 's/slapd-//'`
-elif [ $servid == dirsrv-* ]
+servid=$(get_server_id "@initconfigdir@" $servid)
+if [ $? == 1 ]
 then
-    servid=`echo "$servid" | sed -e 's/dirsrv-//'`
-fi
-configdir="$prefix/etc/dirsrv/slapd-$servid"
-if ! [ -a $configdir ]
-then
-    echo "Invalid server identifier: $servid"
-    echo "Available instances: $instances"
+    usage
+    echo "You must supply a valid server instance identifier.  Use -Z to specify instance name"
+    echo "Available instances: $servid"
     exit 1
 fi
 
-cd $server_sbin
+configdir="@instconfigdir@/slapd-$servid"
+
 if [ $# -eq 0 ]
 then
-	bak_dir=$prefix/var/lib/dirsrv/slapd-$servid/bak/reindex_`date +%Y_%m_%d_%H_%M_%S`
-	./ns-slapd upgradedb -D $configdir -a "$bak_dir"
+	bak_dir=@localstatedir@/lib/@PACKAGE_NAME@/slapd-$servid/bak/reindex_`date +%Y_%m_%d_%H_%M_%S`
+	@sbindir@/ns-slapd upgradedb -D $configdir -a "$bak_dir"
 elif [ $# -lt 2 ]
 then
-	echo "Usage: db2index [-Z instance-name] [-n backend_instance | {-s includesuffix}* -t attribute[:indextypes[:matchingrules]] -T vlvattribute]"
+	usage
 	exit 1
 else
-	./ns-slapd db2index -D $configdir $args
+	@sbindir@/ns-slapd db2index -D $configdir $args
 fi
